﻿package {
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.media.Sound;
	import flash.media.SoundMixer;
	import flash.media.SoundChannel;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.geom.Rectangle;
	import flash.filters.BitmapFilterQuality;
	import flash.filters.BlurFilter;


public class Spectre extends Sprite{
		
		private var _son:Sound;
		private var _canal:SoundChannel;
		private var _grapheSpectre:BitmapData;
		
		public function Spectre(sound:String){
			_grapheSpectre = new BitmapData(900,900,false,0x1A0F00);
			var bitmap:Bitmap = new Bitmap(_grapheSpectre);
			addChild(bitmap);
			bitmap.x=-50;
			bitmap.y=-50;
			
			
			_son = new Sound(new URLRequest(sound));
			_canal = _son.play();
			
			//filtre de flou
			var blur:BlurFilter = new BlurFilter();
			blur.blurX = 6;
			blur.blurY = 6;
			blur.quality = BitmapFilterQuality.MEDIUM;
			//application au Sprite que l'on est en train de créer
			this.filters = [blur];
		
			addEventListener(Event.ENTER_FRAME, onEnterFrame);		
		}
		
		private function onEnterFrame(evenement:Event):void{
			
			
			
			
			//Crée le tableau d'octets et le remplit de données
			var spectre:ByteArray = new ByteArray();
			SoundMixer.computeSpectrum(spectre);
			
			//Effacer le bitmap
			_grapheSpectre.fillRect(_grapheSpectre.rect,0x1A0F00);
			
			_posx=-100;
			_posy=-200;
			//Canal gauche
			for(var i:int=0;i<256;i++){
				//_grapheSpectre.setPixel32(i,20+spectre.readFloat()*20,0xffffffff);
				
				val=spectre.readFloat()*+400;
				_rect= new Rectangle(_posx-val,_posy+(i*10),700,4);
				_grapheSpectre.fillRect(_rect,0x875101);
			}
				
			//Canal droit
			for(var j:int=0;j<256;j++){
				//_grapheSpectre.setPixel32(j,40+spectre.readFloat()*40,0xffffffff);
				
				val2=spectre.readFloat()*400;
				_rect2= new Rectangle(_posx+200+val2,_posy+(j*10),600,7);
				
				_grapheSpectre.fillRect(_rect2,0x432801);
			
			}}
	}

	
}